'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _list = require('antd/lib/list');

var _list2 = _interopRequireDefault(_list);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _olaToolkit = require('ola-toolkit');

var _Pagination = require('../Pagination');

var _Pagination2 = _interopRequireDefault(_Pagination);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var List = (_temp = _class = function (_Component) {
  (0, _inherits3.default)(List, _Component);

  function List() {
    (0, _classCallCheck3.default)(this, List);
    return (0, _possibleConstructorReturn3.default)(this, (List.__proto__ || (0, _getPrototypeOf2.default)(List)).apply(this, arguments));
  }

  (0, _createClass3.default)(List, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          dataSource = _props.dataSource,
          pagination = _props.pagination,
          otherProps = (0, _objectWithoutProperties3.default)(_props, ['dataSource', 'pagination']);


      if ((0, _olaToolkit.isImmutable)(dataSource)) {
        dataSource = dataSource.toArray();
      }

      if (pagination) {
        var total = void 0,
            pageSize = void 0,
            current = void 0,
            paginationProps = void 0;
        var page = pagination.page;

        if (page) {
          if ((0, _olaToolkit.isImmutable)(page)) {
            total = page.get(pagination.totalKey || _Pagination2.default.defaultProps.totalKey);
            pageSize = page.get(pagination.pageSizeKey || _Pagination2.default.defaultProps.pageSizeKey);
            current = page.get(pagination.currentKey || _Pagination2.default.defaultProps.currentKey);
          } else {
            total = page[pagination.totalKey || _Pagination2.default.defaultProps.totalKey];
            pageSize = page[pagination.pageSizeKey || _Pagination2.default.defaultProps.pageSizeKey];
            current = page[pagination.currentKey || _Pagination2.default.defaultProps.currentKey];
          }

          paginationProps = (0, _extends3.default)({
            hideOnSinglePage: true
          }, pagination, {
            total: total,
            pageSize: pageSize,
            current: current
          });

          (0, _keys2.default)(paginationProps).forEach(function (key) {
            if (paginationProps[key] === undefined) {
              delete paginationProps[key];
            }
          });

          delete paginationProps.page;

          return _react2.default.createElement(_list2.default, (0, _extends3.default)({}, otherProps, {
            dataSource: dataSource,
            pagination: paginationProps }));
        }
      }

      return _react2.default.createElement(_list2.default, (0, _extends3.default)({}, this.props, {
        dataSource: dataSource }));
    }
  }]);
  return List;
}(_react.Component), _class.propTypes = (0, _extends3.default)({}, _list2.default.propTypes, {
  dataSource: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object])
}), _class.defaultProps = (0, _extends3.default)({}, _list2.default.defaultProps), _class.Item = _list2.default.Item, _temp);
exports.default = List;
module.exports = exports['default'];