'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ICON_CLASSNAME_PREFIX = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('omit.js');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ICON_CLASSNAME_PREFIX = exports.ICON_CLASSNAME_PREFIX = 'anticon';

var Icon = function Icon(props) {
  var _classNames;

  var spin = props.spin,
      type = props.type,
      className = props.className;


  var classString = (0, _classnames2.default)((_classNames = {}, (0, _defineProperty3.default)(_classNames, ICON_CLASSNAME_PREFIX, true), (0, _defineProperty3.default)(_classNames, ICON_CLASSNAME_PREFIX + '-spin', !!spin || type === 'loading'), (0, _defineProperty3.default)(_classNames, ICON_CLASSNAME_PREFIX + '-' + type, true), _classNames), className);

  return _react2.default.createElement('i', (0, _extends3.default)({}, (0, _omit2.default)(props, ['type', 'spin']), {
    className: classString }));
};

Icon.propTypes = {
  type: _propTypes2.default.string.isRequired,
  className: _propTypes2.default.string,
  title: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  spin: _propTypes2.default.bool,
  style: _propTypes2.default.object
};

exports.default = Icon;